#ifndef MAKEDEPEND
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#endif

#include "cons.h"

#include "mt.h"
#include "editors.h"
#include "messages.h"

#include "m_opl.h"
#include "m_mpu.h"

static musicdriver *drv;

char FileName[64] = "";
char SongName[28] = "untitled."; 
static unsigned inst[16];

msgwin msg1, msg2;

InternalHdr Hdr;

Patteri Patterns[100];
BYTE Orders[256];

InternalSample Inst[100];
char *InstName[100];

BYTE Tempo;
BYTE Speed;

int mxchn;

static SBYTE CurVol[15];

static BYTE ActiveCmd[15];
static BYTE ActiveInfo[15];
static SBYTE NoteDelay[15];
static SBYTE NoteCut[15];

int PlayPat;
int PlayOrd, LoopOrd;
int PlayRow, LoopRow;

static int cha,act[15],lend;

static BYTE Dxx[15];
static BYTE Sxx[15];
static BYTE Hxx[15];
static BYTE Xxx[15];
static BYTE Nxx[15];

static SBYTE Cut;
static int Break;
static SBYTE PatternDelay;

static const unsigned UpdateLength = 30000;
static double tickleft;
static BYTE rowleft;
static BYTE loopstart;
static SBYTE loopcount;
static BYTE OrdRows[256][64];

static enum PlayingModes
{
	Idle,
	Single,
	PatLoop,
	Playing,
	PreScan,
	Scanning
} PlayingMode = Idle;

static void GetActives(int PlayPat, int PlayRow, unsigned a)
{
	ActiveCmd[a] = Patterns[PlayPat][PlayRow][a].Cmd;
	ActiveInfo[a]= Patterns[PlayPat][PlayRow][a].Info;
}

static void TransInfo(int PlayPat, int PlayRow, unsigned a)
{
	int vib=0;
	BYTE info = ActiveInfo[a];
	switch(ActiveCmd[a])
	{
		case 'K':
			drv->midictrl(a, vib=1,
				((Hxx[a]&15) + ((Hxx[a]&0xF0) >> 2))*127/79);
			/* through */
		case 'D':
		{
			BYTE hi, lo;
			if(!info)info = Dxx[a];
			else Dxx[a] = info;
			hi=info>>4;
			lo=info&15;
			if(info==0xFF)CurVol[a]=63;
			else if(hi==0 || hi==15)
			{
				if(CurVol[a] > lo)
					CurVol[a] -= lo;
				else
					CurVol[a] = 0;
				if(hi==15)ActiveCmd[a] = 0;
			}
			else if(lo==0 || lo==15)
			{
				CurVol[a] += hi;
				if(CurVol[a] > 63)CurVol[a] = 63;
				if(lo==15)ActiveCmd[a] = 0;
			}
			drv->volumechange(a, CurVol[a]);
			break;
		}
		case 'C':
			Cut = (info>>4)*10 + (info&15);
			ActiveCmd[a] = 0;
			break;
		case 'B':
			Break = info;
			ActiveCmd[a] = 0;
			break;
		case 'A':
			if(info)Speed = info;
			break;
		case 'T':
			if(info)Tempo = info;
			break;
		case 'H':
		{
			if(!info)info = Hxx[a];
			else Hxx[a] = info;
			drv->midictrl(a, vib=1,
				((info&15) + ((info&0xF0) >> 2))*127/79);						
			break;
		}
		case 'N':
		{
			if(!info)info = Nxx[a];
			else Nxx[a] = info;
			drv->bend(a, info-0x80);
			break;
		}
		case 'S':
			if(!info)info = Sxx[a];
			else Sxx[a] = info;
			switch(info>>4)
			{
				case 0xB:
					if(info&15)
					{
						lend = 1;
						if(loopcount == -1)
							loopcount = info&15;
					}
					else
						loopstart=PlayRow;
					break;
				case 0xC:
					NoteCut[a] = info&15;
					ActiveCmd[a] = 0;
					break;
				case 0xD:
					NoteDelay[a] = info&15;
					ActiveCmd[a] = 0;
					break;
				case 0xE:
					if(PatternDelay == -1)
						PatternDelay = info&15;
					break;
				case 0x8:
					drv->setpan(a, info*8-64);
					break;
			}
			break;
		case 'X':
			if(!info)info = Xxx[a];
			else Xxx[a] = info;
			drv->setpan(a, info/2-64);
			break;
	}
	if(!vib)drv->midictrl(a, 1, 0);
}

void PlaySlot(unsigned p, unsigned r, unsigned a)
{
	if(Patterns[p][r][a].Instru > 0)
	{
		CurVol[a]=Inst[(inst[a]=Patterns[p][r][a].Instru)-1].Volume;
		if(Patterns[p][r][a].Note == 255)
			drv->volumechange(a, CurVol[a]);
	}
	if(Patterns[p][r][a].Note < 254)
	{
		int notenum = Patterns[p][r][a].Note;
		int ins, vol;
		notenum = (notenum&15) + 12*(notenum>>4);
		
		/*
		fprintf(stderr, 
			"Ch %u, Note %u, Vol %u, Ins %u\n",
				a, notenum,
				Patterns[p][r][a].Volume,
				inst[a]);
		*/				
		
		ins=inst[a]-1;
		if(ins<0)ins=0;
		vol = Patterns[p][r][a].Volume;
		if(vol == 255)vol = CurVol[a];
		
		/*
		fprintf(stderr, 
			"CurVol %u, InstVol %u\n",
				CurVol[a],
				(Inst[ins].D[8]>>2));
		*/
		
		vol = vol * (Inst[ins].D[8]>>2) / 63;
		
		drv->noteoff(a);
		drv->patch(a, Inst[ins].FT, Inst[ins].GM, Inst[ins].C4Spd, Inst[ins].D);
		drv->noteon(a, notenum, CurVol[a]=vol);
	}
	else if(Patterns[p][r][a].Volume < 255)
		drv->volumechange(a, CurVol[a]=Patterns[p][r][a].Volume);
		
	act[a]=CurVol[a]!=0;
	if(PlayingMode == Idle)
	{
		GetActives(p, r, a);
		TransInfo(p, r, a);
	#if 0
		PlayingMode = Single;
		loopstart=0;
		loopcount=-1;
		PatternDelay=-1;
		rowleft = 0;
		tickleft = 0.0;
	#endif
	}
	
	for(cha=a=0; a<15; a++)if(act[a])cha++;
}

void UpdPlayStat(void)
{
	unsigned wx=WhereX(), wy=WhereY();
	GotoXY(43, 4);
	SetAttr(0x0B); Gprintf("%sing ", PlayingMode==Idle    ?"  Idl"
									:PlayingMode==PreScan ?"Scann"
									:PlayingMode==Scanning?"  Sav"
														  :" Play");
	SetAttr(0x03); Gprintf("%02d", PlayRow);
	SetAttr(0x0B); Gprintf("[Ord[");
	SetAttr(0x03); Gprintf("%02X", PlayOrd);
	SetAttr(0x0B); Gprintf("]=");
	SetAttr(0x03); Gprintf("%02d", PlayPat);
	SetAttr(0x0B); Gprintf("] A");
	SetAttr(0x03); Gprintf("%02X", Speed);
	SetAttr(0x0B); Gprintf(", T");
	SetAttr(0x03); Gprintf("%02X", Tempo);
	SetAttr(0x0B); Gprintf(", ");
	SetAttr(0x03); Gprintf("%-2d", cha);
	GotoXY(wx, wy);
}

void Silence(void)
{
	unsigned a;
	for(a=0; a<15; a++)
	{
		drv->noteoff(a);
		NoteDelay[a] = 0;
		NoteCut[a] = -1;
		ActiveCmd[a] = 0;
		ActiveInfo[a] =0;
		CurVol[a] = 63;
	}
	PlayingMode = Idle;
	Cut=Break=-1;
	PatternDelay=-1;
	tickleft=0.0;
	rowleft=0;
	loopstart=0;
	loopcount=-1;
	
	UpdPlayStat();
	
	cha=0;
	memset(&act,0,sizeof(act));
}

void StartLoopingPattern(int pat, int row)
{
	Silence();
	PlayRow = row;
	PlayPat = pat;
	PlayingMode = PatLoop;
}
void StartPlayingOrder(int ord, int row)
{
	Silence();
	PlayRow = row;
	PlayPat = Orders[PlayOrd = ord];
	PlayingMode = Playing;
}
void StartScanning(int stepno)
{
	Silence();
	memset(OrdRows, 0, sizeof(OrdRows));
	PlayPat = Orders[PlayOrd = PlayRow = 0];
	PlayingMode = stepno==1 ? PreScan : Scanning;
}
void StartPlayingPatRow(int pat, int row)
{
	int a;
	for(a=0; a<Hdr.OrdNum; a++)
		if(Orders[a] == pat)
		{
			StartPlayingOrder(a, row);
			return;
		}
	StartLoopingPattern(pat, row);
}
void UpdatePlayer(void)
{
	/* The usleep is here first to keep cursor fixed as
	 * long as possible before we probably move it away.
	 */
	extern void MIDIDelay(unsigned);
	
	
	if(PlayingMode != Scanning)
	{
		drv->delay(UpdateLength);
	}
	else
	{
		MIDIDelay(UpdateLength);
	}
	
	DrawMessageWindow(&msg1, 0);
	DrawMessageWindow(&msg2, 0);
	
	if(PlayingMode == Idle)return;
	
	UpdPlayStat();
	
	/* Rows played in a second = InTempo*2/InSpeed/5
     * InSpeed = number of ticks per row
     * Length of one tick is 2.5 / InTempo seconds.
     */
    
	while(tickleft < 1E-4)
	{
		unsigned a;
		
		lend=0;
		
		if(!rowleft)
		{
			extern void MIDIMarkLoopStart(void);
			
			if(++OrdRows[PlayOrd][PlayRow] > 1
			&& loopcount == -1 && PatternDelay == -1
			&& (PlayingMode == Scanning || PlayingMode == PreScan)) 
			{
				if(PlayingMode == PreScan)LoopOrd=PlayOrd, LoopRow=PlayRow;
				PlayingMode = Idle;
				Silence();
				return;
			}
			
			if(PlayingMode == Scanning
			&& LoopOrd==PlayOrd && LoopRow==PlayRow)
				MIDIMarkLoopStart();
			
			for(a=0; a<15; a++)GetActives(PlayPat,PlayRow,a);
		}
		
		for(a=0; a<15; a++)
			TransInfo(PlayPat,PlayRow,a);
		
		for(a=0; a<15; a++)
		{
			if(!NoteDelay[a])
			{
				PlaySlot(PlayPat, PlayRow, a);
				NoteDelay[a] = -1;
			}
			else if(NoteDelay[a] > 0)
				NoteDelay[a]--;
				
			if(!NoteCut[a])
			{
				drv->noteoff(a);
				NoteCut[a] = -1;
			}
			else if(NoteCut[a] > 0)
				NoteCut[a]--;
		}
			
		if(!rowleft)rowleft = Speed;
		if(rowleft-- == 1)
		{
			if(PatternDelay <= 0)
			{
				if(PlayingMode == Single)
				{
					PlayingMode = Idle;
					return;
				}
				if(lend)
				{
					if(!loopcount)loopcount = -1;
					else if(loopcount > 0)
					{
						Cut = Break = -1;
						PlayRow = loopstart;
						loopcount--;
					}
				}
				if(!lend || loopcount == -1)
				{
					if(Cut >= 0)PlayRow = Cut;
					if(Break >= 0)
					{
						PlayOrd = Break;
						if(Cut < 0)PlayRow = 0;
					}
					else
						if(Cut >= 0)PlayOrd++;
					
					if(Cut >= 0 || Break >= 0)
					{
						Break = Cut = -1;
						lend=1;
					}
					else
						if(++PlayRow >= 64)
						{
							PlayOrd++;
							lend=1;
							PlayRow=0;
						}
						
					if(lend)loopstart=PlayRow;
					
					if(PlayOrd >= Hdr.OrdNum)PlayOrd=0;
					
					if(PlayingMode != PatLoop)PlayPat=Orders[PlayOrd];
					
					PatternDelay = -1;
				}
				for(a=0; a<15; a++)
					NoteDelay[a] = 0;
			}
			else
				PatternDelay--;
		}
		
		tickleft += 2.5E6 / UpdateLength / Tempo;
	}
	
	tickleft--;
	
	if(PlayingMode == Scanning)UpdatePlayer();
}

static void DispFile(void)
{
	GotoXY(2, 3);
	SetAttr(0x0B); Gprintf("FileName: [");
	SetAttr(0x03); Gprintf("%-63s", FileName);
	SetAttr(0x0B); Gprintf("]");
	GotoXY(2, 4);
	SetAttr(0x0B); Gprintf("Songname: [");
	SetAttr(0x03); Gprintf("%-28s", SongName);	
	SetAttr(0x0B); Gprintf("]");
}

static void InitPattns(void)
{
	int a, b, c;
	for(a=0; a<100; a++)
		for(b=0; b<64; b++)
			for(c=0; c<15; c++)
			{
				Patterns[a][b][c].Note = 255;
				Patterns[a][b][c].Instru=0;
				Patterns[a][b][c].Volume=255;
				Patterns[a][b][c].Cmd   =0;
				Patterns[a][b][c].Info  =0;
			}
	for(a=0; a<100; a++)
	{
		memset(&Inst[a], 0, sizeof(Inst[a]));
		Inst[a].Volume = 63;
		Inst[a].GM     = 1;
		Inst[a].D[8]   = 255;
		Inst[a].C4Spd  = 8363;
		InstName[a] = NULL;
	}
	
	Tempo = 0x7D;
	Speed = 0x06;
}

static void Load(const char *filename)
{
	FILE *fp = fopen(filename, "rb");
	InternalSample *smp[100];
	BYTE *buf, *s;
	long size=0;
	unsigned a;
	if(!fp)return;
#if 0
	for(a=0; ; a++)
	{
		size=(BYTE)fgetc(fp);
		size|=((BYTE)fgetc(fp))<<8;
		if(a==8)break;
		fseek(fp, size, SEEK_CUR);
	}
#else
	fseek(fp, 0, SEEK_END);
	size=ftell(fp);
	rewind(fp);
#endif
	buf = (BYTE *)malloc(size);
	if(!buf){fclose(fp);return;}
	fread(buf, size, 1, fp);
	fclose(fp);
	
	strncpy(FileName, filename, sizeof(FileName)-1);
	FileName[sizeof(FileName)-1]=0;
	
	InitPattns();
	
	s = buf;
	if(s[1] > 2)
	{
		strncpy(SongName, (char *)s, sizeof(SongName)-1);
		SongName[sizeof(SongName)-1]=0;
		for(;*s++;);
	}
	else
		SongName[0] = 0;	
	
	Hdr = *(InternalHdr *)s;
	
	s += (Hdr.PatNum&512) ? 11 : 10;
	
	memcpy(Orders, s, Hdr.OrdNum&255);
	s += Hdr.OrdNum&255;
	
	Tempo = Hdr.InTempo;
	Speed = Hdr.InSpeed & 127;
	
	for(a=0; a<Hdr.InsNum; a++)
	{
		smp[a] = (InternalSample *)s;
		s += sizeof(InternalSample);
		if(Hdr.PatNum&512)
		{
			InstName[a] = strdup((char *)s);
			s += strlen((char *)s)+1;
		}
		else
 			InstName[a] = NULL;
 			
 		Inst[a] = *smp[a];
 		if(!Inst[a].GM)Inst[a].GM=1;
	}
	for(a=0; a<16; a++)inst[a] = 0;
	Hdr.PatNum &= 511;
	
	for(a=0; a<Hdr.PatNum; a++)
	{
		BYTE *q = s;
		int wait=1;
		WORD w = *(WORD *)s;
		int r;
		q += 2;
		s += w+2;
		for(r=0; w; r++)
		{
			BYTE b;
			if(wait > 1)
			{
				wait--;
				continue;
			}
			for(;;)
			{
				unsigned ch;
				int gotins=0;
				
				b = (w--, *q++);
				if(b < 16)break;
				
				ch = b&15;
				if(b&16)
					Patterns[a][r][ch].Info = (w--, *q++);
				if(b&32)
				{
					BYTE puh = (w--, *q++);
					if(!(Hdr.OrdNum&256))
					getins:
						gotins=1, inst[ch] = (w--, *q++);
					else if(puh & 128)
					{
						if(puh < 254)puh &= 127;
						goto getins;
					}
					Patterns[a][r][ch].Note = puh<254?puh+16:puh;
				}
				if(b&64)Patterns[a][r][ch].Volume = (w--, *q++);
				if(b&128)Patterns[a][r][ch].Cmd = (w--, *q++) | 64;
				
				if((b&32) || gotins)
					Patterns[a][r][ch].Instru = inst[ch];
			}
			if(b==15)
				wait = (w--, *q++);
			else if(b>0)
				wait += b;
		}
	}
	Hdr.OrdNum &= 255;
		
	free(buf);
	
	Silence();
}

static void WipeOut(void)
{
	unsigned x,y,x2=(COLS-3)&~3,y2=(LINES-3)&~3;
	HideCursor();
	SetAttr(7);
	for(y=1; y<y2; y++)GotoXY(1+x2,y),ClrEOL();
	for(; y<=LINES; y++)GotoXY(1,y),ClrEOL();
	#define d(X,Y) for(x=0; x<(COLS-3)/4; x++) \
						for(y=0; y<(LINES-3)/4; y++) \
							GotoXY(x*4+X+1,1+y*4+Y),Gputchar(' '); \
					usleep(14000);
	
	d(0,0);
	d(2,0); d(0,2); d(2,2);
	d(1,1); d(3,1); d(1,3);
	d(1,0); d(3,2); d(0,3);
	d(3,0); d(0,1); d(2,3);
	d(2,1); d(1,2); d(3,3);
	GotoXY(1, 1);
	ShowCursor();
}

static void disphelp(const musicdriver *p, void *a)
{
	if(p==(const musicdriver *)a)return;
	printf(" -%c\t%s\n", p->optchar, p->name);
	printf("   \tMax channels: %d\n", p->maxch);
}

int main(int argc, const char **argv)
{
	int key;
	char driver = 'm';
	
	registerdrivers(&OPLDriver, &MPUDriver, NULL);
	
	while(--argc)
	{
		const char *s = *++argv;
		if(*s == '-')
		{
			while(*++s)
			{
				if(*s=='?')
				{
					printf(" -?\tHelp\n");
					if(s[1])
					{
						const musicdriver *p = finddriver(s[1]);
						if(p)
						{
							foreachdriver(disphelp, (void *)p);
							printf("\n");
							disphelp(p, NULL);
							printf("\n%s\n", p->longdescr);
							return 0;
						}
					}
					foreachdriver(disphelp, NULL);
					return 0;
				}
				if(finddriver(*s))
					driver=*s;
			}
		}
	}
	
	drv = finddriver(driver);
	
	InitCons();
	
/*	assert(!ioperm(0x388, 4, 1));
*/	
	if(LINES < 50 || COLS < 80)
	{
		printf("Sorry, your terminal is smaller than 80x50 (is %dx%d).\n", COLS,LINES);
		DoneCons();
		return ENOSPC;
	}
	
	if(drv->detect() < 0)
	{
		printf("Sorry, sound output device detected.\n");
		sleep(3);
		printf("Oops.\n");
		sleep(1);
		printf("Sorry, sound output device was not detected.\n");
		DoneCons();
		return ENODEV;
	}
	drv->reset();
	
	mxchn = (COLS-6) / 14;
	
	SetAttr(0x17);
	ClrScr();
	SetAttr(0x30);
	Gprintf(" Test demo pre-alpha (C) Bisqwit");
	ClrEOL();
	
	InitMsgWindow(&msg1, 35,8, COLS-3,12);
	InitMsgWindow(&msg2, 2,47,COLS-1,LINES);
	
	SetAttr(7);
	GotoXY(1,2), ClrEOL();
	GotoXY(1,3), ClrEOL();
	GotoXY(1,4), ClrEOL();
	GotoXY(1,5), ClrEOL();
	GotoXY(1,6), ClrEOL();
	GotoXY(1,7), ClrEOL();
	
	Load("nesmusa.$$$");
//	Load("/okd/bc31/joed/joe.mar");

	DispFile();
	
	Message(&msg1, "  Author's page: http://iki.fi/bisqwit/");
	Message(&msg1, "Play:F5=song,F6=patloop,F7=here,F8=stop");
	Message(&msg1, "^L=redraw,^Q=quit - most keys like in ST3");
	
	for(key=F2; ;)
	{
		switch(key)
		{
			case F2:
				key=PatnEdit();
				break;
			case F3:
				key=InstEdit();
				break;
			default:
				/* Don't want to loop forever in case of bug */
				key=F2;
		}
		if(key == Esc)break;
	}
	
	WipeOut();
	
	DoneCons();
	
	drv->close();
	
	return 0;	
}
