#ifndef __MAIN_Hdef
#define __MAIN_Hdef

#ifndef MAKEDEPEND
#include <errno.h>
#endif

#include "music.h"
#include "messages.h"

typedef struct Channel
{
	BYTE Note, Instru, Volume;
	BYTE Cmd, Info;	
} Channel;

typedef Channel Row[15];
typedef Row Patteri[64];

extern Patteri Patterns[100];
extern BYTE Orders[256];
extern InternalSample Inst[100];
extern InternalHdr Hdr;
extern char *InstName[100];

extern int mxchn;
extern BYTE Tempo;
extern BYTE Speed;

extern void PlaySlot(unsigned p, unsigned r, unsigned a);
extern void Silence();
extern void UpdatePlayer(void);
extern void StartLoopingPattern(int pat, int row);
extern void StartPlayingOrder(int ord, int row);
extern void StartPlayingPatRow(int pat, int row);
extern void StartScanning(int stepno);

extern int PlayPat, PlayOrd, PlayRow;

extern msgwin msg1, msg2;

#define assert(a) (void)((a)||(\
	fprintf(stderr,\
		"*** At line %d in %s:\n"\
		"    Assertion failed: \"%s\"\n"\
		"    Errno: %d (%s)\n",\
		__LINE__,__FILE__,#a,errno,strerror(errno)),exit(-1)))
#endif /* __MAIN_Hdef */
